Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMBrowser.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMBrowser.java	(revision 2730)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMBrowser.java	(revision 2731)
@@ -60,19 +60,22 @@
 import org.txm.rcp.messages.TXMUIMessages;
 
 /**
- * Call the internal browser of RCP specialized for TXM editions. 
+ * Call the internal browser of RCP specialized for TXM editions.
  * 
- * A Text can be set then the user can browse pages and others texts of the same corpus 
+ * A Text can be set then the user can browse pages and others texts of the same corpus
  * 
  * @author mdecorde.
  */
-@SuppressWarnings("restriction") //$NON-NLS-1$
+@SuppressWarnings("restriction")
 public class TXMBrowser extends WebBrowserEditor {
 	
 	/** The Constant ID. */
 	public final static String ID = "org.txm.rcp.editors.TXMBrowser"; //$NON-NLS-1$
+	
 	private ProgressListener progresslistener;
+	
 	private List<String> wordids;
+	
 	private List<String> lineids;
 	
 	/** The edition. */
@@ -86,14 +89,14 @@
 	
 	/** The source. */
 	private Object source;
-
+	
 	/**
 	 * Instantiates a new txm browser.
 	 */
 	public TXMBrowser() {
-
+		
 	}
-
+	
 	/**
 	 * Gets the browser.
 	 *
@@ -104,6 +107,7 @@
 		return webbrowser.getBrowser();
 	}
 	
+	@Override
 	public void setPartName(String partName) {
 		super.setPartName(partName);
 	}
@@ -119,41 +123,40 @@
 		if (progresslistener != null)
 			this.getBrowser().removeProgressListener(progresslistener);
 		progresslistener = new ProgressListener() {
+			
 			@Override
-			public void changed(ProgressEvent event) {
-			}
-
+			public void changed(ProgressEvent event) {}
+			
 			@Override
 			public void completed(ProgressEvent event) {
 				Page currentpage = getCurrentPage();
-				//System.out.println("Highlight ! "+currentpage.getEdition().getText()+" wordids ="+wordids);
-			
+				// System.out.println("Highlight ! "+currentpage.getEdition().getText()+" wordids ="+wordids);
+				
 				for (String wordid : wordids) {
 					String highlightscript = "try { var elt = document.getElementById(\"" + wordid + "\");" + //$NON-NLS-1$ //$NON-NLS-2$
-					"elt.style.backgroundColor=\"#F9D0D0\";" //$NON-NLS-1$
-					+ 
-					"elt.style.paddingLeft=\"3px\";" + //$NON-NLS-1$
-					"elt.style.paddingRight=\"3px\";" + //$NON-NLS-1$
-					"elt.style.paddingTop=\"1px\";" + //$NON-NLS-1$
-					"elt.style.paddingBottom=\"1px\";" + //$NON-NLS-1$
-					"} catch (e) { };"; //$NON-NLS-1$
-
+							"elt.style.backgroundColor=\"#F9D0D0\";" //$NON-NLS-1$
+							+
+							"elt.style.paddingLeft=\"3px\";" + //$NON-NLS-1$
+							"elt.style.paddingRight=\"3px\";" + //$NON-NLS-1$
+							"elt.style.paddingTop=\"1px\";" + //$NON-NLS-1$
+							"elt.style.paddingBottom=\"1px\";" + //$NON-NLS-1$
+							"} catch (e) { };"; //$NON-NLS-1$
+					
 					getBrowser().execute(highlightscript);
 				}
-
+				
 				for (String wordid : lineids) {
 					String highlightscript = "try { var elt = document.getElementById(\"" + wordid + "\");" + //$NON-NLS-1$ //$NON-NLS-2$
-					"elt.style.backgroundColor=\"#F9A0A0\";" + //$NON-NLS-1$
-					"elt.style.paddingLeft=\"3px\";" + //$NON-NLS-1$
-					"elt.style.paddingRight=\"3px\";" + //$NON-NLS-1$
-					"elt.style.paddingTop=\"1px\";" + //$NON-NLS-1$
-					"elt.style.paddingBottom=\"1px\";" + //$NON-NLS-1$
-					"} catch (e) { };"; //$NON-NLS-1$
-
+							"elt.style.backgroundColor=\"#F9A0A0\";" + //$NON-NLS-1$
+							"elt.style.paddingLeft=\"3px\";" + //$NON-NLS-1$
+							"elt.style.paddingRight=\"3px\";" + //$NON-NLS-1$
+							"elt.style.paddingTop=\"1px\";" + //$NON-NLS-1$
+							"elt.style.paddingBottom=\"1px\";" + //$NON-NLS-1$
+							"} catch (e) { };"; //$NON-NLS-1$
+					
 					getBrowser().execute(highlightscript);
 				}
-				if(lineids.size() > 0)
-				{
+				if (lineids.size() > 0) {
 					String script = "try { document.getElementById(\"" + lineids.get(0) + "\").scrollIntoView(true); } catch (e) { };"; //$NON-NLS-1$ //$NON-NLS-2$
 					getBrowser().execute(script);
 				}
@@ -161,7 +164,7 @@
 		};
 		getBrowser().addProgressListener(progresslistener);
 	}
-
+	
 	/**
 	 * Sets the edition.
 	 *
@@ -170,7 +173,7 @@
 	public void setEdition(Edition edition) {
 		this.edition = edition;
 	}
-
+	
 	/**
 	 * Make page label.
 	 *
@@ -180,7 +183,7 @@
 		return currentPage.getName()
 				+ " / " + currentPage.getEdition().getNumPages(); //$NON-NLS-1$
 	}
-
+	
 	/**
 	 * Show page.
 	 *
@@ -192,7 +195,7 @@
 		this.webBrowser.setURL(currentPage.toURL());
 		page_label.setText(makePageLabel());
 	}
-
+	
 	/**
 	 * First text.
 	 */
@@ -200,20 +203,20 @@
 		Text current = this.currentPage.getEdition().getText();
 		Project corpus = current.getProject();
 		Text firstText = corpus.getFirstText();
-
+		
 		if (firstText != null) {
-			String editionName = corpus.getDefaultEdition();
-			currentPage = firstText.getEdition(editionName).getFirstPage(); 
+			String editionName = corpus.getDefaultEditionName();
+			currentPage = firstText.getEdition(editionName).getFirstPage();
 			if (currentPage == null) {
 				StatusLine.setMessage(TXMUIMessages.noPreviousText);
 				return;
 			}
-			this.setEdition(firstText.getEdition(editionName)); 
+			this.setEdition(firstText.getEdition(editionName));
 			this.webBrowser.setURL(currentPage.toURL());
 			page_label.setText(makePageLabel());
 		}
 	}
-
+	
 	/**
 	 * Last text.
 	 */
@@ -221,14 +224,14 @@
 		Text current = this.currentPage.getEdition().getText();
 		Project b = current.getProject();
 		Text lastText = b.getLastText();
-
+		
 		if (lastText != null) {
-			currentPage = lastText.getEdition(b.getDefaultEdition()).getFirstPage(); 
+			currentPage = lastText.getEdition(b.getDefaultEditionName()).getFirstPage();
 			if (currentPage == null) {
 				StatusLine.setMessage(TXMUIMessages.noTextNext);
 				return;
 			}
-			this.setEdition(lastText.getEdition(b.getDefaultEdition())); 
+			this.setEdition(lastText.getEdition(b.getDefaultEditionName()));
 			this.webBrowser.setURL(currentPage.toURL());
 			page_label.setText(makePageLabel());
 		}
@@ -243,20 +246,20 @@
 		this.webBrowser.setURL(currentPage.toURL());
 		page_label.setText(makePageLabel());
 	}
-
+	
 	/**
 	 * Last page.
 	 */
 	public void lastPage() {
 		// System.out.println(Messages.TxmBrowser_2+currentPage);
-
+		
 		if (currentPage != null && currentPage.getFile().equals(edition.getLastPage().getFile()))
 			return;
 		currentPage = edition.getLastPage();
 		this.webBrowser.setURL(currentPage.toURL());
 		page_label.setText(makePageLabel());
 	}
-
+	
 	/**
 	 * Previous page.
 	 */
@@ -266,15 +269,17 @@
 			Page previous = edition.getPreviousPage(currentPage);
 			if (previous == currentPage) {
 				previousText(true);
-			} else {
-				currentPage = previous; 
+			}
+			else {
+				currentPage = previous;
 				this.webBrowser.setURL(currentPage.toURL());
 			}
-		} else
+		}
+		else
 			firstPage();
 		page_label.setText(makePageLabel());
 	}
-
+	
 	/**
 	 * Next page.
 	 */
@@ -284,44 +289,48 @@
 			Page next = edition.getNextPage(currentPage);
 			if (currentPage == next) {
 				nextText();
-			} else {
+			}
+			else {
 				currentPage = next;
 				this.webBrowser.setURL(currentPage.toURL());
 			}
-
-		} else
+			
+		}
+		else
 			firstPage();
 		page_label.setText(makePageLabel());
 	}
-
+	
 	/**
 	 * Previous text.
-	 * @param fromNextText 
+	 * 
+	 * @param fromNextText
 	 */
 	public void previousText(boolean fromNextText) {
-
+		
 		Text current = this.currentPage.getEdition().getText();
 		Project corpus = current.getProject();
 		Text previousText = corpus.getPreviousText(current);
-
+		
 		if (previousText != null) {
-			String editionName = corpus.getDefaultEdition();
+			String editionName = corpus.getDefaultEditionName();
 			if (fromNextText) {
-				currentPage = previousText.getEdition(editionName).getLastPage();	
-			} else {
+				currentPage = previousText.getEdition(editionName).getLastPage();
+			}
+			else {
 				currentPage = previousText.getEdition(editionName).getFirstPage();
 			}
 			if (currentPage == null) {
 				StatusLine.setMessage(TXMUIMessages.noPreviousText);
 				return;
 			}
-			this.setEdition(previousText.getEdition(editionName)); 
+			this.setEdition(previousText.getEdition(editionName));
 			this.webBrowser.setURL(currentPage.toURL());
 			page_label.setText(makePageLabel());
 		}
 		// System.out.println("Previous texts "+previousText);
 	}
-
+	
 	/**
 	 * Next text.
 	 */
@@ -329,28 +338,30 @@
 		Text current = this.currentPage.getEdition().getText();
 		Project b = current.getProject();
 		Text nextText = b.getNextText(current);
-
+		
 		if (nextText != null) {
-			currentPage = nextText.getEdition(b.getDefaultEdition()).getFirstPage(); 
+			currentPage = nextText.getEdition(b.getDefaultEditionName()).getFirstPage();
 			if (currentPage == null) {
 				StatusLine.setMessage(TXMUIMessages.noTextNext);
 				return;
 			}
-			this.setEdition(nextText.getEdition(b.getDefaultEdition())); 
+			this.setEdition(nextText.getEdition(b.getDefaultEditionName()));
 			this.webBrowser.setURL(currentPage.toURL());
 			page_label.setText(makePageLabel());
 		}
 		// System.out.println("Next texts "+nextText);
 	}
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.ui.internal.browser.WebBrowserEditor#createPartControl(org.eclipse.swt.widgets.Composite)
 	 */
 	@Override
 	public void createPartControl(Composite parent) {
 		try {
 			super.createPartControl(parent);
-		} catch (Exception e) {
+		}
+		catch (Exception e) {
 			System.err.println(TXMUIMessages.couldNotLaunchTheInternalWebBrowserYouMustSetThatParameterInThePreferencesMenuColonGeneralSupWebNavigator);
 			return;
 		}
@@ -359,7 +370,7 @@
 		navigLayout.justify = true;
 		Composite panneau = new Composite(parent, SWT.NONE);
 		panneau.setLayout(navigLayout);
-
+		
 		RowLayout subLayout = new RowLayout(SWT.HORIZONTAL);
 		subLayout.pack = true;
 		subLayout.center = true;
@@ -368,17 +379,17 @@
 		Composite subPanneau = new Composite(panneau, SWT.NONE);
 		subPanneau.setLayout(subLayout);
 		subPanneau.setLayoutData(new RowData(450, 22));
-
+		
 		Button firstText = new Button(subPanneau, SWT.FLAT);
 		Button previousText = new Button(subPanneau, SWT.FLAT);
-		Button first = new Button(subPanneau, SWT.FLAT|SWT.PUSH);
-		Button previous = new Button(subPanneau, SWT.FLAT|SWT.PUSH);
+		Button first = new Button(subPanneau, SWT.FLAT | SWT.PUSH);
+		Button previous = new Button(subPanneau, SWT.FLAT | SWT.PUSH);
 		page_label = new Label(subPanneau, SWT.NONE);
-		Button next = new Button(subPanneau, SWT.FLAT|SWT.PUSH);
-		Button last = new Button(subPanneau, SWT.FLAT|SWT.PUSH);
-		Button nextText = new Button(subPanneau, SWT.FLAT|SWT.PUSH);
-		Button lastText = new Button(subPanneau, SWT.FLAT|SWT.PUSH);
-
+		Button next = new Button(subPanneau, SWT.FLAT | SWT.PUSH);
+		Button last = new Button(subPanneau, SWT.FLAT | SWT.PUSH);
+		Button nextText = new Button(subPanneau, SWT.FLAT | SWT.PUSH);
+		Button lastText = new Button(subPanneau, SWT.FLAT | SWT.PUSH);
+		
 		// set sizes
 		page_label.setLayoutData(new RowData(50, 20));
 		firstText.setLayoutData(new RowData(30, 20));
@@ -389,15 +400,15 @@
 		nextText.setLayoutData(new RowData(30, 20));
 		previousText.setLayoutData(new RowData(30, 20));
 		lastText.setLayoutData(new RowData(30, 20));
-
 		
+		
 		// set labels
 		page_label.setText(""); //$NON-NLS-1$
 		firstText.setImage(IImageKeys.getImage(IImageKeys.CTRLREWINDSTART));
 		firstText.setToolTipText("|<<");
 		previousText.setImage(IImageKeys.getImage(IImageKeys.CTRLREWIND));
 		previousText.setToolTipText(TXMUIMessages.previousText);
-		first.setImage(IImageKeys.getImage(IImageKeys.CTRLSTART)); 
+		first.setImage(IImageKeys.getImage(IImageKeys.CTRLSTART));
 		first.setToolTipText(TXMUIMessages.common_beginning);
 		previous.setImage(IImageKeys.getImage(IImageKeys.CTRLREVERSE));
 		previous.setToolTipText(TXMUIMessages.previousPage);
@@ -410,63 +421,63 @@
 		lastText.setImage(IImageKeys.getImage(IImageKeys.CTRLFASTFORWARDEND));
 		lastText.setToolTipText(">>|");
 		
-
+		
 		// set listeners
 		first.addSelectionListener(new SelectionListener() {
-
+			
 			@Override
 			public void widgetDefaultSelected(SelectionEvent e) {
 				firstPage();
 			}
-
+			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
 				firstPage();
 			}
 		});
 		previous.addSelectionListener(new SelectionListener() {
-
+			
 			@Override
 			public void widgetDefaultSelected(SelectionEvent e) {
 				previousPage();
 			}
-
+			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
 				previousPage();
 			}
 		});
 		next.addSelectionListener(new SelectionListener() {
-
+			
 			@Override
 			public void widgetDefaultSelected(SelectionEvent e) {
 				nextPage();
 			}
-
+			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
 				nextPage();
 			}
 		});
 		last.addSelectionListener(new SelectionListener() {
-
+			
 			@Override
 			public void widgetDefaultSelected(SelectionEvent e) {
 				lastPage();
 			}
-
+			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
 				lastPage();
 			}
 		});
 		nextText.addSelectionListener(new SelectionListener() {
-
+			
 			@Override
 			public void widgetDefaultSelected(SelectionEvent e) {
 				nextText();
 			}
-
+			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
 				nextText();
@@ -474,24 +485,24 @@
 		});
 		// set listeners
 		previousText.addSelectionListener(new SelectionListener() {
-
+			
 			@Override
 			public void widgetDefaultSelected(SelectionEvent e) {
 				previousText(false);
 			}
-
+			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
 				previousText(false);
 			}
 		});
 		lastText.addSelectionListener(new SelectionListener() {
-
+			
 			@Override
 			public void widgetDefaultSelected(SelectionEvent e) {
 				lastText();
 			}
-
+			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
 				lastText();
@@ -499,51 +510,51 @@
 		});
 		// set listeners
 		firstText.addSelectionListener(new SelectionListener() {
-
+			
 			@Override
 			public void widgetDefaultSelected(SelectionEvent e) {
 				firstText();
 			}
-
+			
 			@Override
 			public void widgetSelected(SelectionEvent e) {
 				firstText();
 			}
 		});
-
+		
 		subPanneau.pack();
 		panneau.pack();
-
+		
 		FormLayout parentLayout = new FormLayout();
-
+		
 		FormData datatop = new FormData();
 		datatop.top = new FormAttachment(0, 0);
 		datatop.left = new FormAttachment(0, 0);
 		datatop.right = new FormAttachment(100, 0);
 		datatop.bottom = new FormAttachment(panneau, 0);
 		webBrowser.setLayoutData(datatop);
-
+		
 		FormData databottom = new FormData(200, 30);
 		databottom.bottom = new FormAttachment(100, 0);
 		databottom.left = new FormAttachment(30, -100);
 		databottom.right = new FormAttachment(80, 100);
 		panneau.setLayoutData(databottom);
-
+		
 		parent.setLayout(parentLayout);
 		parent.pack();
 		
 		MenuManager menuManager = new MenuManager();
 		Menu menu = menuManager.createContextMenu(getBrowser());
-
+		
 		// Set the MenuManager
 		getBrowser().setMenu(menu);
 		ISelectionProvider selProvider = new ISelectionProvider() {
 			
 			@Override
-			public void setSelection(ISelection selection) { }
+			public void setSelection(ISelection selection) {}
 			
 			@Override
-			public void removeSelectionChangedListener(ISelectionChangedListener listener) { }
+			public void removeSelectionChangedListener(ISelectionChangedListener listener) {}
 			
 			@Override
 			public ISelection getSelection() {
@@ -583,29 +594,29 @@
 			}
 			
 			@Override
-			public void addSelectionChangedListener(ISelectionChangedListener listener) { }
+			public void addSelectionChangedListener(ISelectionChangedListener listener) {}
 		};
 		getSite().registerContextMenu(menuManager, selProvider);
 		getSite().setSelectionProvider(selProvider);
 		
-		//System.out.println("Browser menu: "+getBrowser().getMenu());
+		// System.out.println("Browser menu: "+getBrowser().getMenu());
 	}
 	
-	static String SCRIPT01 = "var html = \"\";"+
-			"if (typeof window.getSelection != \"undefined\") {"+ // modern Web browsers
-			    "var sel = window.getSelection();"+
-			    "if (sel.rangeCount) {"+
-			        "var container = document.createElement(\"div\");"+
-			        "for (var i = 0, len = sel.rangeCount; i < len; ++i) {"+
-			            "container.appendChild(sel.getRangeAt(i).cloneContents());"+
-			        "}"+
-			        "html = container.innerHTML;"+
-			    "}"+
-			"} else if (typeof document.selection != \"undefined\") {"+ // for IE < 11
-			    "if (document.selection.type == \"Text\") {"+
-			        "html = document.selection.createRange().htmlText;"+
-			    "}" +
+	static String SCRIPT01 = "var html = \"\";" +
+			"if (typeof window.getSelection != \"undefined\") {" + // modern Web browsers
+			"var sel = window.getSelection();" +
+			"if (sel.rangeCount) {" +
+			"var container = document.createElement(\"div\");" +
+			"for (var i = 0, len = sel.rangeCount; i < len; ++i) {" +
+			"container.appendChild(sel.getRangeAt(i).cloneContents());" +
 			"}" +
+			"html = container.innerHTML;" +
+			"}" +
+			"} else if (typeof document.selection != \"undefined\") {" + // for IE < 11
+			"if (document.selection.type == \"Text\") {" +
+			"html = document.selection.createRange().htmlText;" +
+			"}" +
+			"}" +
 			"return html";
 	
 	// return the span@id of the current selection
@@ -615,26 +626,26 @@
 			+ "else \n"
 			+ "return node.ChildNodes;\n"
 			+ "}\n"
-			+ "function findSpans(c, a) {\n"+
-			"    for (var i = 0 ; i < c.length ; i++) {\n"+
-			"        if (c.item(i).tagName == \"SPAN\") {\n"+
-			"            var id = c.item(i).getAttribute(\"id\")\n"+
-			"            if (id.indexOf(\"w_\") == 0)\n"+
-			"                a.push(id);\n"+
-			"        } else if (c.item(i).nodeType == 1) {\n"+
-			"            findSpans(c.item(i).children, a);\n"+
-			"        }\n"+
-			"    }\n"+
-			"}\n"+
-			"    var all = [];"+
-			"    var sel = window.getSelection();"+
-			"    if (sel.rangeCount == 0){"+
-			"        return all;"+
-			"    }"+
-			"\n"+
-			"    var range = sel.getRangeAt(0);"+
-			"    var frag = range.cloneContents();alert(frag);alert(frag.children);"+
-			"    findSpans(frag.children, all);"+
+			+ "function findSpans(c, a) {\n" +
+			"    for (var i = 0 ; i < c.length ; i++) {\n" +
+			"        if (c.item(i).tagName == \"SPAN\") {\n" +
+			"            var id = c.item(i).getAttribute(\"id\")\n" +
+			"            if (id.indexOf(\"w_\") == 0)\n" +
+			"                a.push(id);\n" +
+			"        } else if (c.item(i).nodeType == 1) {\n" +
+			"            findSpans(c.item(i).children, a);\n" +
+			"        }\n" +
+			"    }\n" +
+			"}\n" +
+			"    var all = [];" +
+			"    var sel = window.getSelection();" +
+			"    if (sel.rangeCount == 0){" +
+			"        return all;" +
+			"    }" +
+			"\n" +
+			"    var range = sel.getRangeAt(0);" +
+			"    var frag = range.cloneContents();alert(frag);alert(frag.children);" +
+			"    findSpans(frag.children, all);" +
 			"    return all;";
 	
 	public String getTextSelectionDOM() {
@@ -642,17 +653,17 @@
 	}
 	
 	public Object getWordIDsSelection() {
-		System.out.println("WORDS IDS "+getBrowser().evaluate(SCRIPT02));
+		System.out.println("WORDS IDS " + getBrowser().evaluate(SCRIPT02));
 		return getBrowser().evaluate(SCRIPT02);
 	}
 	
 	public String getTextSelection() {
-		System.out.println("DOM="+getTextSelectionDOM());
-		String rez =  getTextSelectionDOM().replaceAll("<[^>]+>", "");
-		System.out.println("STR="+rez);
+		System.out.println("DOM=" + getTextSelectionDOM());
+		String rez = getTextSelectionDOM().replaceAll("<[^>]+>", "");
+		System.out.println("STR=" + rez);
 		return rez;
-	} 
-
+	}
+	
 	/**
 	 * Gets the current page.
 	 *
@@ -661,4 +672,4 @@
 	public Page getCurrentPage() {
 		return currentPage;
 	}
-}
\ No newline at end of file
+}
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java	(revision 2730)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java	(revision 2731)
@@ -99,7 +99,7 @@
  * @author sjacquot
  *
  */
-public abstract class TXMEditor<T extends TXMResult> extends EditorPart implements ITXMResultEditor<T> {
+public abstract class TXMEditor<T extends TXMResult> extends EditorPart implements ITXMResultEditor<TXMResult> {
 	
 	/**
 	 * ID to use in plugin.xml to contribute to the top toolbar.
@@ -188,7 +188,7 @@
 	/**
 	 * Linked editors.
 	 */
-	protected ArrayList<EditorPart> linkedEditors = null;
+	protected ArrayList<ITXMResultEditor<TXMResult>> linkedEditors = null;
 	
 	/**
 	 * debug purpose variable -> easier to fetch information that the getResult() method
@@ -1776,7 +1776,8 @@
 	 * 
 	 * @param editor
 	 */
-	public void addLinkedEditor(final EditorPart editor) {
+	@Override
+	public void addLinkedEditor(final ITXMResultEditor<TXMResult> editor) {
 		
 		if (this.linkedEditors == null) {
 			this.linkedEditors = new ArrayList<>();
@@ -1835,7 +1836,8 @@
 	 * 
 	 * @param editor
 	 */
-	public void removeLinkedEditor(EditorPart editor) {
+	@Override
+	public void removeLinkedEditor(ITXMResultEditor<TXMResult> editor) {
 		if (this.linkedEditors != null) {
 			if (this.linkedEditors.remove(editor)) {
 				// Debug
@@ -1853,7 +1855,8 @@
 	 * 
 	 * @return
 	 */
-	public ArrayList<EditorPart> getLinkedEditors() {
+	@Override
+	public ArrayList<ITXMResultEditor<TXMResult>> getLinkedEditors() {
 		return this.linkedEditors;
 	}
 	
@@ -1863,12 +1866,13 @@
 	 * @param editorClass
 	 * @return
 	 */
-	public EditorPart getLinkedEditor(Class editorClass) {
-		EditorPart editor = null;
+	@Override
+	public <E extends ITXMResultEditor<TXMResult>> E getLinkedEditor(Class<E> editorClass) {
+		E editor = null;
 		if (this.linkedEditors != null) {
 			for (int i = 0; i < this.linkedEditors.size(); i++) {
-				if (this.linkedEditors.get(i).getClass().equals(editorClass)) {
-					editor = this.linkedEditors.get(i);
+				if (this.linkedEditors.get(i).getClass().equals(editorClass)) { // TODO won't work if the linkedEditor inherits E.class
+					editor = (E) this.linkedEditors.get(i);
 					break;
 				}
 			}
@@ -1882,12 +1886,13 @@
 	 * @param editorClass
 	 * @return
 	 */
-	public ArrayList<EditorPart> getLinkedEditors(Class editorClass) {
-		ArrayList<EditorPart> editors = new ArrayList<>();
+	@Override
+	public <E extends ITXMResultEditor<TXMResult>> ArrayList<E> getLinkedEditors(Class<E> editorClass) {
+		ArrayList<E> editors = new ArrayList<>();
 		if (this.linkedEditors != null) {
 			for (int i = 0; i < this.linkedEditors.size(); i++) {
 				if (this.linkedEditors.get(i).getClass().equals(editorClass)) {
-					editors.add(this.linkedEditors.get(i));
+					editors.add((E) this.linkedEditors.get(i));
 				}
 			}
 		}
